<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        $sql = <<<'SQL'
        CREATE TABLE plants (
            id          BIGINT GENERATED always AS IDENTITY PRIMARY KEY,

            company_id  BIGINT NOT NULL,

            code        INT NOT NULL CHECK (code >= 1000) UNIQUE,
            name        TEXT NOT NULL UNIQUE, -- CITEXT use extension
            address     TEXT NOT NULL,

            created_at  TIMESTAMP NOT NULL DEFAULT NOW(),
            updated_at TIMESTAMP NOT NULL DEFAULT NOW(),
            deleted_at TIMESTAMP,

            FOREIGN KEY (company_id) REFERENCES companies (id)
        );
        SQL;

        DB::statement($sql);
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('plants');
    }
};
